PROC BROWSE( TableName, FormName, StartRec, TopRow, LeftColumn, BottomRow, 
    RightColumn )

   private Char,       ;contains character the user last pressed
           CurRow,     ;multirecord form row number of the record that
                       ;contains the current record
           RefreshScr  ;tells whether or not to redraw screen each pass

   View TableName
   PickForm FormName
   MOVETO RECORD StartRec

   CurRow=1
   NumRows=BottomRow-TopRow+1
   RefreshScr=True

   while true

     IF RefreshScr THEN
       echo normal
       echo off                         ;display the form on the screen
       RefreshScr = False
       @ 1,0   ?? TODAY()
       @ 1,9   ?? TIME()
       @ 1,18  ?? MEMLEFT()  ?? " Bytes free"
       @ 1,66  ?? "      of "   ?? NRECORDS(TableName)
     ENDIF

     @ 1,9   ?? TIME()
     @ 1,66  ?? "     "
     @ 1,66  ?? RECNO()

     CurRow = RowNo()

     paintcanvas attribute 7 
         TopRow, LeftColumn, BottomRow, RightColumn
     paintcanvas attribute 112 
         TopRow+CurRow-1, LeftColumn, TopRow+CurRow-1, RightColumn

     Char=getchar()

     switch
       ;---------------------- DOWN ARROW ----------------------
       case Char=-80 :
         DOWN
         CurRow=CurRow+1           ;keep track of where the PAL cursor is
         if CurRow>NumRows then    ;did cursor go beyond end of form?
           RefreshScr=True
         endif
       ;---------------------- UP ARROW ----------------------
       case Char=-72 :
         UP
         CurRow=CurRow-1           ;keep track of where the PAL cursor is
         if CurRow<1 then          ;did cursor go beyond top of form
           RefreshScr=True
         endif
       ;---------------------- PGUP Key ----------------------
       case Char=-73 :
         PGUP
         RefreshScr=True
       ;---------------------- PGDN Key ----------------------
       case Char=-81 :
         PGDN
         RefreshScr=True
       ;---------------------- HOME LEY ----------------------
       case Char=-71 :
          HOME
         RefreshScr=True
       ;---------------------- END KEY ----------------------
       case Char=-79 :
         END
         RefreshScr=True
       ;---------------------- ANY OTHER KEY ----------------------
       otherwise :
         BarRow = RECNO()
         Return Char
     endswitch
   endwhile
endproc

;*************************************************************************
;                          SAMPLE APPLICATION
;*************************************************************************

proc SortByName()
    message "sorting ..."
    Sort "Browse" on "Name"
endproc

proc SortByCompany()
    message "sorting ..."
    Sort "Browse" on "Company"
endproc

proc InvalidKey()
    beep
    message "You pressed an invalid key; Press RETURN to continue ..."
	dummy = getchar()
endproc



StartingRow = 1


while TRUE
    ReturnChar = Browse( "Browse", "F", StartingRow, 5, 1, 22, 78 )
    StartingRow = BarRow
    switch
        case ReturnChar = -60  : SortByName()
        case ReturnChar = -61  : SortByCompany()
        case ReturnChar =  27  : exit
        otherwise              : InvalidKey()
    endswitch
endwhile

